> ## Documentation Index
> Fetch the complete documentation index at: https://docs.ulm.m1amdocs.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Retrieve a subscription’s associated users

> Retrieves a list of all Connect users associated to the ULM subscription specified by the subscriptionId number. Each result in the list is a subscription-to-user association, and it includes:
* The subscription, including its properties and attributes
* The association flags and attributes (if any) of the association



## OpenAPI

````yaml /portal/Amdocs_Media-ULM-Released-resolved.yaml get /subscription/{subscriptionId}/users
openapi: 3.0.1
info:
  title: Connect APIs
  description: >-
    The Connect/ULM APIs enables clients to manage all aspects against Connect's
    data entities that they are permitted to manage. The data entities supported
    include: (1) USER - a unique individual, (2) RUNTIME - endpoint to which
    services are delivered (e.g. mobile tablet, browser), (3) GROUP - a
    collection of user entities, (4) ACCOUNT - relationship between a USER and
    service provider, (5) SUBSCRIPTION - package of entitlements to a specific
    service, and (6) FEATURE - fine-grained entitlement that defines what a user
    can do for a particular service.


    The APIs offer endpoints for users to onboard, authenticate and manage their
    profile. Please review our OIDC APIs that can be accessed through an active
    web session within the application (i.e. any JavaScript running on the
    server itself) or through authorizing a client application through OIDC or
    OAuth 2.0.


    The majority of these APIs require a user context (session cookie or access
    token) to access their functionality.


    All of the APIs can be accessed via a organization specific domain that was
    provided to you during onboarding.
  version: Draft-GO
servers:
  - url: https://nxt-ulm-pdt.m1amdocs.io/platform/rest/v85
security:
  - cookieAuth: []
  - OIDC: []
tags:
  - name: Account
    description: ULM Account APIs enable standard CRUD operations on ULM account entities.
  - name: Authentication
    description: >-
      Connect authentication APIs open and close user sessions (user login and
      logout).
  - name: Group and Soft Profile
    description: >-
      Connect Group and Soft Profile APIs enable clients to perform group
      management and soft profile functions. A group is a collection of one or
      more Connect entities, typically a user entity. For example, a group can
      be a household that contains 4 users all within the same family. A Soft
      Profile User is a user that can be a minor user or guest user, and they
      are not required to sign up or subscribe to a service. For example, a Soft
      Profile User can be a minor that does not have an email and therefore can
      only access the services if the parent is first authenticated.
  - name: Process
    description: >-
      Connect Process APIs initiate process steps. Connect's library of
      processes include for example Onboarding with Email and Password. These
      processes are intended to provided an preset user journey that your UI can
      follow in steps. 


      A step can be an inital step, one of many subsequent steps, or a final
      step. Some processes may only require one step from start to end.
  - name: Runtime
    description: >-
      Connect Runtimes APIs enables retrieval of Devices that are used by Users
      to interact with ULM.
  - name: Subscription
    description: >-
      Connect Subscription APIs enable standard CRUD operations on a
      subscription entity.
  - name: User
    description: Connect User APIs enable standard CRUD operations on a user entity.
paths:
  /subscription/{subscriptionId}/users:
    get:
      tags:
        - Subscription
      summary: Retrieve a subscription’s associated users
      description: >-
        Retrieves a list of all Connect users associated to the ULM subscription
        specified by the subscriptionId number. Each result in the list is a
        subscription-to-user association, and it includes:

        * The subscription, including its properties and attributes

        * The association flags and attributes (if any) of the association
      operationId: getSubscriptionUsersAssociationUsingGET
      parameters:
        - name: offset
          in: query
          description: The initial position to search from
          required: false
          allowEmptyValue: false
          style: form
          explode: true
          schema:
            type: integer
            format: int32
            default: 0
          example: 0
        - name: size
          in: query
          description: The maximum number of results to return
          required: false
          allowEmptyValue: false
          style: form
          explode: true
          schema:
            type: integer
            format: int32
          example: 1
        - name: subscriptionId
          in: path
          description: |-
            The unique ID number of the subscription
            Example: 202
          required: true
          style: simple
          explode: false
          schema:
            type: integer
            format: int64
          example: 202
      responses:
        '200':
          description: OK - successfully retrieved the subscriptions's associated users
          headers:
            X-Total-Count:
              description: >-
                A response header indicating the total number of entities
                available
              style: simple
              explode: false
              schema:
                type: integer
                format: int64
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: >-
                    #/components/schemas/UserAssociationWithSubscriptionResponseDto
        '400':
          description: Invalid Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GenericPagination400Dto'
        '401':
          description: Authentication Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Generic401Dto'
        '403':
          description: Authtorization Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Generic403Dto'
        '404':
          description: The requested resource was not found or does not exist.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SubscriptionResponse404'
components:
  schemas:
    UserAssociationWithSubscriptionResponseDto:
      title: UserAssociationWithSubscription
      type: object
      properties:
        attributes:
          $ref: '#/components/schemas/GenericAssociationAttributeResponseDto'
        flags:
          $ref: '#/components/schemas/AssociationFlags'
        subscription:
          $ref: '#/components/schemas/SubscriptionResponseDto'
        user:
          $ref: '#/components/schemas/UserResponseDto'
      description: User to Subscription Association
    GenericPagination400Dto:
      type: object
      properties:
        fieldErrors:
          type: array
          items:
            $ref: '#/components/schemas/FieldErrorDto'
        operationErrors:
          type: array
          items:
            $ref: '#/components/schemas/GenericPagination400OperationErrors'
    Generic401Dto:
      type: object
      properties:
        operationError:
          deprecated: true
          allOf:
            - $ref: '#/components/schemas/OperationErrorDto'
        stackTrace:
          type: string
          description: Optional, returned only in debug mode.
        operationErrors:
          type: array
          items:
            $ref: '#/components/schemas/Generic401DtoOperationErrors'
      description: General Payload for Authentication Error.
    Generic403Dto:
      type: object
      properties:
        operationError:
          deprecated: true
          allOf:
            - $ref: '#/components/schemas/OperationErrorDto'
        stackTrace:
          type: string
          description: Optional, returned only in debug mode.
        operationErrors:
          type: array
          items:
            $ref: '#/components/schemas/Generic403DtoOperationErrors'
      description: General Payload for Authorization Error.
    SubscriptionResponse404:
      type: object
      properties:
        operationErrors:
          type: array
          items:
            $ref: '#/components/schemas/SubscriptionResponse404OperationErrorDto'
    GenericAssociationAttributeResponseDto:
      type: object
      additionalProperties:
        type: object
      description: Group to User Association Response Attributes
    AssociationFlags:
      type: object
      additionalProperties:
        type: string
      description: The flags that specify the relationship between the associated entities.
      example:
        mint.permission.read: 'true'
        mint.role: mint.role.user
    SubscriptionResponseDto:
      type: object
      properties:
        activatedDate:
          type: number
          description: The entity’s activation date and time, expressed in UNIX Epoch time
          format: int64
          example: 1651180416000
        attributes:
          $ref: '#/components/schemas/SubscriptionAttributeResponseDto'
        createdDate:
          type: number
          description: The entity’s creation date and time in UNIX Epoch time
          format: int64
          example: 1651180416000
        deactivatedDate:
          type: number
          description: >-
            The entity’s deactivation date and time, expressed in UNIX Epoch
            time
          format: int64
          example: 1651180416000
        displayName:
          type: string
          description: The display name of the entity
          example: Entity display name
        id:
          $ref: '#/components/schemas/EntityId'
        status:
          $ref: '#/components/schemas/EntityStatus'
        suspendedDate:
          type: number
          description: The entity’s suspension date and time, expressed in UNIX Epoch time
          format: int64
          example: 1651180416000
        type:
          $ref: '#/components/schemas/EntityType'
        updatedDate:
          type: number
          description: >-
            The most recent date and time that the entity was updated, expressed
            in UNIX Epoch time
          format: int64
          example: 1651180416000
      description: The data fields that define a ULM subscription.
    UserResponseDto:
      type: object
      properties:
        id:
          type: integer
          description: The unique ID number of the Connect entity.
          format: int64
          example: 1
        avatarUrl:
          type: string
          description: The URL of the user’s avatar
          example: http://myavatar/johnsmith
        displayName:
          type: string
          description: The display name of the entity
          example: Entity display name
        status:
          $ref: '#/components/schemas/EntityStatus'
        type:
          $ref: '#/components/schemas/EntityType'
        credentialSet:
          type: boolean
          description: >-
            Whether or not the user currently has a password set. This field
            exists because the 'credential' field is not returned once set; this
            field allows to provide some information about the password
          example: true
        passcodeSet:
          type: boolean
          description: >-
            Whether or not the user currently has a passcode set. This field
            exists because the 'passcode' field is not returned once set; this
            field allows to provide some information about the passcode
          example: false
        pinSet:
          type: boolean
          description: >-
            Whether or not the user currently has a PIN set. This field exists
            because the 'pin' field is not returned once set; this field allows
            to provide some information about the passcode
          example: false
        locked:
          type: boolean
          description: >-
            Whether or not the user currently is locked user due to multiple
            invalid login attemptes
          example: false
        lockedUntil:
          type: number
          description: >-
            The time untill the user is locked due to multiple invalid login
            attemptes
          format: int64
          example: 1651180416000
        createdDate:
          type: number
          description: The entity’s creation date and time in UNIX Epoch time
          format: int64
          example: 1651180416000
        activatedDate:
          type: number
          description: The entity’s activation date and time, expressed in UNIX Epoch time
          format: int64
          example: 1651180416000
        deactivatedDate:
          type: number
          description: >-
            The entity’s deactivation date and time, expressed in UNIX Epoch
            time
          format: int64
          example: 1651180416000
        suspendedDate:
          type: number
          description: The entity’s suspension date and time, expressed in UNIX Epoch time
          format: int64
          example: 1651180416000
        updatedDate:
          type: number
          description: >-
            The most recent date and time that the entity was updated, expressed
            in UNIX Epoch time
          format: int64
          example: 1651180416000
        attributes:
          $ref: '#/components/schemas/UserAttributesResponseDto'
      description: The object that contains user properties and attributes.
    FieldErrorDto:
      title: FieldErrorDto
      type: object
      properties:
        code:
          type: string
          description: logical error code
          example: NotNull
          deprecated: true
        code_v2:
          type: string
          description: logical error code
          example: not-null
        field:
          type: string
          description: Name of the field in error where error happens
          example: name
        message:
          type: string
          description: Human readable error message
          example: Value must not be null
        rejectedValue:
          type: object
          description: >-
            Rejected value. Only visible when the logging level is at least
            DEBUG
          example: bad value
      description: An error arising from a particular input field or its value
    GenericPagination400OperationErrors:
      type: object
      properties:
        code:
          type: string
          enum:
            - invalid-page-offset
            - max-return-page-size
            - page-size-error
        message:
          type: string
          example: The requested page size is larger than the permitted max page size.
    OperationErrorDto:
      title: OperationErrorDto
      required:
        - code
      type: object
      properties:
        code:
          type: string
          description: The business error code
        message:
          type: string
          description: The message that describes the error
          example: Bad user input
        type:
          type: string
          description: >-
            The exception class that caused the error, returned only in debug
            mode.
          deprecated: true
        authorities:
          type: array
          description: Returned only in debug mode.
          items:
            type: string
      description: The data model that contains the Operation Error response details.
    Generic401DtoOperationErrors:
      type: object
      properties:
        code:
          type: string
          enum:
            - authentication-required
        message:
          type: string
          example: Full Authentication Required
    Generic403DtoOperationErrors:
      type: object
      properties:
        code:
          type: string
          enum:
            - ACCESS_FORBIDDEN
            - security-challenge-failed
        message:
          type: string
          example: Access Denied
    SubscriptionResponse404OperationErrorDto:
      type: object
      properties:
        code:
          type: string
          enum:
            - subscription-not-found
        message:
          type: string
          example: >-
            com.uxpsystems.mint.framework.subscription.model.GenericSubscription[id:1]
    SubscriptionAttributeResponseDto:
      type: object
      properties:
        paymentProviderSubscriptions:
          type: array
          items:
            $ref: '#/components/schemas/PaymentProviderSubscriptionResponseDto'
      description: Subscription attributes Dto
    EntityId:
      type: integer
      description: The unique ID of an entity.
      format: int64
      example: 1
    EntityStatus:
      type: string
      description: >-
        The status of the entity. Possible values include:

        * activating - The entity has been provisioned, but is not yet ready to
        be used or consumed.

        * activated - The entity is active, and the functionality to which it is
        tied is enabled.

        * suspended - The entity is temporarily deactivated, but can be
        reactivated in the future.

        * deactivated - The entity is permanently deactivated, and may be
        deleted from the system in the near future.

        * pending - The entity has been added but is not yet verified for use. 
        It may be linked to an existing entity in order to eventually replace
        the original entity.

        * unknown - This is a generic, catch all state for specific entities.


        Note: This  field is the current status in GET calls, and the desired
        status in PUT and POST calls.
      example: activated
      enum:
        - activating
        - activated
        - suspended
        - deactivated
        - pending
        - unknown
    EntityType:
      type: string
      description: A particular type of a given entity.
      example: com.uxpsystems.ulm.entity.RegularEntityType
    UserAttributesResponseDto:
      type: object
      properties:
        com.uxpsystems.mint.user.FamilyName:
          type: string
          description: User's last name.
        com.uxpsystems.mint.user.GivenName:
          type: string
          description: User's given name(s).
        com.uxpsystems.mint.user.Language:
          type: string
          description: User's locale preference.
          example: fr_CA, en
        domain:
          type: string
          description: >-
            It contains the domain used during onboarding, usually fetched from
            the HTTP "X-Forwarded-Host" header.
        preferredNotificationChannel:
          type: string
          description: >-
            References another attribute that contains the preferred
            notification channel.
        branding:
          type: string
          description: >-
            it contains an optional brand name that can be added to the user
            during onboarding.
        secret2FATotp:
          type: string
          description: Read-only obfuscated secret for 2FA TOTP.
        aliases:
          type: array
          description: Read-only non-verified authentication identifiers.
          items:
            $ref: '#/components/schemas/UserAliasDto'
        mobiles:
          type: array
          description: >-
            Read-only list of verified mobile phones numbers that can be used as
            authentication identifiers.
          items:
            $ref: '#/components/schemas/UserMobileDto'
        emails:
          type: array
          description: >-
            Read-only list of emails verified rmail addresses that can be used
            as  authentication identifiers.
          items:
            $ref: '#/components/schemas/UserEmailDto'
        socialConnections:
          type: array
          description: Read-only list of social service provider connections.
          items:
            $ref: '#/components/schemas/UserSocialConnectionDto'
      description: User Attributes
    PaymentProviderSubscriptionResponseDto:
      type: object
      properties:
        id:
          $ref: '#/components/schemas/EntityId'
        providerSubscriptionId:
          type: string
          description: User's Provider Subscription ID
          example: f2369f70b673eb71ae2e44438c675ab4a090ccbf
        internalProviderSubscriptionId:
          type: string
          description: >-
            Unique reference account identifier generated by the client of the
            Payment Provider
          example: HBOMax_77799990278191
        productId:
          type: string
          description: Payment Provider's Product identifier purchased
          example: HBOMax
        subscriptionStartDate:
          type: number
          description: Service start date
          format: int64
          example: 1629849600000
        subscriptionEndDate:
          type: number
          description: Service end date
          format: int64
          example: 1629849600000
        productDescription:
          type: string
          description: Name of the product attached to the service
          example: HBO Max
        billingState:
          type: string
          description: Financial state of the service (subscription)
          example: FREE_TRIAL
          enum:
            - FREE_PERIOD
            - FREE
            - TRIAL
            - FREE_TRIAL
            - BILLING_COMPLETED
            - PENDING_PAUSE
            - PENDING_RESUME
            - UNBILLED
            - PAUSED
            - GOOD_STANDING
            - OTHER
        subscriptionStatus:
          type: string
          description: Status of the service
          example: ACTIVE
          enum:
            - ACTIVE
            - ACTIVATION
            - SUSPENDED
            - CANCELLED
            - DELETED
            - DRYRUN
            - EXPIRED
            - INCOMPLETE
            - LEGACY_SUSPENDED
            - TRIALING
            - UNPAID
            - PAST_DUE
            - UNKNOWN
            - PROCESSING
            - PENDING_ACTIVATION
            - PENDING_CANCEL
            - PENDING_PAUSE
            - PENDING_RESUME
            - PAUSED
            - UPGRADED
            - OTHER
        nextSubscriptionBillingDate:
          type: number
          description: Next billing date for the service
          format: int64
          example: 1629849600000
        nextSubscriptionPrice:
          type: number
          description: price/cost of the next Service cycle
          format: double
          example: 1
        nextSubscriptionCurrency:
          type: string
          description: Price/cost of the next Service cycle
          example: MXN
        subscriptionPrice:
          type: number
          description: Price/cost of the subscription/service
          format: double
          example: 1
        subscriptionCurrency:
          type: string
          description: Currency of the purchased Service
          example: MXN
        purchaseSource:
          type: string
          description: Source/channel of service purchase
          example: PUSH_NOTIFICATION
          enum:
            - OPERATOR
            - MARKETPLACE
            - PUSH_NOTIFICATION
            - IN_APP_PURCHASE
            - RECURRING
            - ONE_TIME
        serviceType:
          type: string
          description: Type of service to be purchased
          example: RECURRING
          enum:
            - RECURRING
            - ONE_TIME
        additionalFields:
          $ref: '#/components/schemas/METADATA'
        plmCode:
          type: string
          description: Plm code
          example: hbomax.dcb.standard
        entitledThrough:
          type: number
          description: End date of service availability period
          format: int64
          example: 1629849600000
        paymentMethod:
          $ref: '#/components/schemas/PaymentDetailResponseDto'
      description: Dto with mapped properties from the Payment Provider.
    UserAliasDto:
      type: object
      properties:
        id:
          type: string
          description: internal unique id
        alias:
          type: string
          description: alias value
      description: Alias Dto
    UserMobileDto:
      type: object
      properties:
        id:
          type: string
          description: internal unique id
        number:
          type: string
          description: phone number
        mfaoption:
          type: boolean
          description: flag that indicates that number is registered for MFA
      description: Mobile phone Dto
    UserEmailDto:
      type: object
      properties:
        id:
          type: string
          description: internal unique id
        email:
          type: string
          description: email address value
        mfaoption:
          type: boolean
          description: flag that indicates that email is registered for MFA
      description: Email Dto
    UserSocialConnectionDto:
      type: object
      properties:
        id:
          type: string
          description: internal unique id
        providerId:
          type: string
          description: id of the provider
          example: facebook, google
        socialId:
          type: boolean
          description: Provider specific unique id.
      description: Social Connection Dto
    METADATA:
      type: object
      additionalProperties:
        type: string
        properties:
          key:
            type: string
          value:
            type: object
      description: Useful for storing additional information.
    PaymentDetailResponseDto:
      type: object
      properties:
        paymentMethodId:
          type: string
          description: Unique MarketOne identifier of the payment method.
          example: 0a8977b2-d37b-11eb-92ce-0208f2d661bf
        paymentMethodVid:
          type: string
          description: Unique identifier of the provider's payment method.
          example: 0a8977b2-d37b-11eb-92ce-0208f2d661bf
        paymentMethodName:
          type: string
          description: Name associated with the Payment Method
          example: Postpaid
        paymentTypeName:
          type: string
          description: Payment method type. It is only applicable for MAP.
          example: Postpaid
          enum:
            - Postpaid
            - Prepaid
            - Wallet
        active:
          type: boolean
          description: Flag to determine if it is active methtod
          example: true
        primary:
          type: boolean
          description: Flag to determine if it is primary methtod.
          example: true
        status:
          type: string
          description: optional status field.
          example: ACTIVE
        additionalFields:
          $ref: '#/components/schemas/METADATA'
        billingAccountNumber:
          type: string
          description: Billing account number.
          example: '2293912935'
        cardNumber:
          type: string
          description: The Primary Account Number (PAN) aka card Number.
          example: '40345334878402386634'
        expirationMonth:
          type: string
          description: The card expiration month.
          example: '2028'
        expirationYear:
          type: string
          description: The card expiration year.
          example: '11'
        classType:
          type: string
          description: Class name of this instance.
          example: com.uxpsystems.mint.attributes.MerchantAcceptedPayment
        id:
          $ref: '#/components/schemas/EntityId'
      description: Payment Method Detail dto
  securitySchemes:
    cookieAuth:
      type: apiKey
      name: JSESSIONID
      in: cookie
    OIDC:
      type: oauth2
      description: OAuth 2.0 Authentication
      flows:
        implicit:
          authorizationUrl: /oidc/authorize
          scopes:
            openid: >-
              Enables OIDC by requesting the ID Token. Without this scope, the
              request is merely OAuth 2.0
            profile: Requests the claims name, family_name, given_name, and picture
            email: Requests the claims email and email_verified
            phone: Requests the claims phone_number and phone_number_verified
            offline_access: Requests that a refresh token be issued.
            entitlements: Enables the "entitlements" claim.
        password:
          tokenUrl: /oidc/token
          scopes:
            openid: >-
              Enables OIDC by requesting the ID Token. Without this scope, the
              request is merely OAuth 2.0
            profile: Requests the claims name, family_name, given_name, and picture
            email: Requests the claims email and email_verified
            phone: Requests the claims phone_number and phone_number_verified
            entitlements: Enables the "entitlements" claim.
        clientCredentials:
          tokenUrl: /oidc/token
          scopes:
            openid: >-
              Enables OIDC by requesting the ID Token. Without this scope, the
              request is merely OAuth 2.0
            profile: Requests the claims name, family_name, given_name, and picture
            email: Requests the claims email and email_verified
            phone: Requests the claims phone_number and phone_number_verified
            entitlements: Enables the "entitlements" claim.
        authorizationCode:
          authorizationUrl: /oidc/authorize
          tokenUrl: /oidc/token
          scopes:
            openid: >-
              Enables OIDC by requesting the ID Token. Without this scope, the
              request is merely OAuth 2.0
            profile: Requests the claims name, family_name, given_name, and picture
            email: Requests the claims email and email_verified
            phone: Requests the claims phone_number and phone_number_verified
            offline_access: Requests that a refresh token be issued.
            entitlements: Enables the "entitlements" claim.

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.